<template>
  <div class="row flex items-center full-height bg-white">
    <div class="full-height flex column col-8 q-pa-xs">
      <div class="q-title q-pt-md q-pl-sm">Users</div>
      <q-scroll-area
        class="col-grow q-mt-sm"
      >
        <q-table
          :columns="computedUsersColumns"
          :data="computedUsers"
          :pagination.sync="usersPagination"
          :rows-per-page-options="[5, 10, 15, 20, 25, 50, 100]"
          :loading="isComputingUsers"
        />
      </q-scroll-area>
    </div>
    <div class="full-height flex column col-4 q-pa-xs">
      <div class="q-title q-pt-md q-pl-sm">Timings</div>
      <q-scroll-area
        class="col-grow q-mt-sm"
      >
        <q-table
          :columns="computedTimingsColumns"
          :data="computedTimings"
          :pagination.sync="timingsPagination"
          :rows-per-page-options="[5, 10, 15, 20, 25, 50, 100]"
          :loading="isComputingTimestamps"
        >
          <tr
            slot="header"
            slot-scope="props"
          >
            <q-th
              v-for="(column) in computedTimingsColumns"
              :key="column.name"
              :style="{
                width:  '150px'
              }"
            >
              <q-input
                v-model="timingFilters[column.field]"
                :after="[{icon: 'search'}]"
                :float-label="column.label"
                dense
              />
            </q-th>
          </tr>
        </q-table>
      </q-scroll-area>
    </div>
  </div>
</template>

<script>
    import apiMixin from '../../mixins/apiMixin';

    export default {
      name: 'test-view',
      mixins: [apiMixin],
      props: {
        users: Array,
        attachedColumns: Object,
        columnCameras: Object,
        timeZone: String,
        date: String,
        isTimeZoneDetected: Boolean,
        timestampColumns: Object,
      },
      created() {
        this.$nextTick(() => {
          this.recalculate();
        });
      },
      watch: {
        columns() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        attachedColumns() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        timestampColumns() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        columnCameras() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        timeZone() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        date() {
          this.$nextTick(() => {
            this.recalculate();
          });
        },
        timingFilters: {
          deep: true,
          handler() {
            this.$nextTick(() => {
              console.log('heh');
              this.computeTimings();
            });
          },
        },
      },
      methods: {
        computeUsers() {
          this.isComputingUsers = true;
          this.computeUsersInTiming({
            users: this.users,
            columns: this.computedUsersColumns,
            attachedColumns: this.attachedColumns,
          })
            .then((res) => {
              this.computedUsers = res;
              this.isComputingUsers = false;

              this.$eventHub.$emit('timingUsersComputed', [
                this.computedUsersColumns.map(({ name }) => name),
                ...res.map((record) => this.computedUsersColumns.map(({ name }) => name).map((col) => record[col])),
              ]);
            });
        },
        computeTimings() {
          const timestampColumns = {};
          Object.entries(this.timestampColumns).forEach(([key, value]) => {
            timestampColumns[key] = [value[0], value[1]];
          });

          this.isComputingTimestamps = true;
          this.computeTimingsInTiming({
            users: this.users,
            attachedColumns: this.attachedColumns,
            timestampColumns,
            columnCameras: this.columnCameras,
            timeZone: this.timeZone,
            date: this.date,
            isTimeZoneDetected: this.isTimeZoneDetected,
            filters: this.timingFilters,
          })
            .then((res) => {
              this.computedTimings = res;
              this.isComputingTimestamps = false;

              this.$eventHub.$emit('timingTimingsComputed', [
                this.computedTimingsColumns.map(({ name }) => name),
                ...res.map((record) => this.computedTimingsColumns.map(({ name }) => name).map((col) => record[col])),
              ]);
            });
        },
        recalculate() {
          this.computeUsers();
          this.computeTimings();
        },
      },
      data() {
        return {
          isComputingUsers: false,
          isComputingTimestamps: false,

          usersPagination: {
            rowsPerPage: 10,
          },
          timingsPagination: {
            rowsPerPage: 10,
          },

          timingFilters: {
            race_id: '',
            concurent_no: '',
            timestamp: '',
            camera: '',
          },

          computedUsers: [],
          computedTimings: [],
        };
      },
      computed: {
        computedUsersColumns() {
          return Object.entries(this.attachedColumns)
            .filter(([key, value]) => (
              !(key in this.timestampColumns) || ((key in this.timestampColumns) && !this.timestampColumns[key][0])
            ) && value)
            .map((item) => item[1])
            .map((value) => ({
              name: value,
              label: value,
              field: value,
              align: 'left',
              sortable: true,
            }));
        },
        computedTimingsColumns() {
          return [
            ...['race_id', 'concurent_no'].map((item) => ({
              name: item,
              label: item,
              field: item,
              align: 'left',
              sortable: true,
            })),
            ...['timestamp', 'camera'].map((item) => ({
              name: item,
              label: item,
              field: item,
              align: 'left',
              sortable: true,
            })),
          ];
        },
      },
    };
</script>
